<!-- eslint-disable vue/multi-word-component-names -->
<script setup lang="ts">
import { nextTick, onMounted, ref, computed, watch } from 'vue'
import type { VForm } from 'vuetify/components'
import http from '@/services/http'
import AttendanceService from '@/service/attendance'
import { useAttendanceStore } from '@/stores/attendance'
import type { Attendance } from '@/types/Attendance'
import { useAuthStore } from '@/stores/auth'

const AuthStore = useAuthStore()
const currentUser = AuthStore.getCurrentUser()
const attendanceStore = useAttendanceStore()
const dialogcheckin = ref(false)
const dialogcheckout = ref(false)
const form = ref(false)
const status = ref(localStorage.getItem('status') !== 'working' ? 'unemployed' : 'working')
const refForm = ref<VForm | null>(null)
const checkinClicked = ref(JSON.parse(localStorage.getItem('checkinClicked')) || false)
function onSubmit() {}
// const confirm = ref(false)
let editedIndex = 0
const date = new Date()
const formattedDate = date.toLocaleString('en-GB', {
  year: 'numeric',
  month: 'short',
  day: '2-digit',
  hour: '2-digit',
  minute: '2-digit',
  second: '2-digit',
  timeZone: 'Asia/Bangkok'
})
const checkedOutItems = ref<any[]>([])

const filteredAttendancesHistory = computed(() => {
  return attendanceStore.attendances
    .filter((item: any) => item.fullName === currentUser.fullName)
    .slice(0, -1)
    .reverse()
})

const filteredAttendancesToday = computed(() => {
  return attendanceStore.attendances
    .filter((item: any) => item.fullName === currentUser.fullName)
    .slice(-1)
    .reverse()
})

function closeDialog() {
  dialogcheckin.value = false
  nextTick(() => {
    attendanceStore.clearForm()
  })
}

const isCheckedOut = (item: any) => {
  return checkedOutItems.value.some((i) => i.id === item.id)
}

function saveCheckinClickedState() {
  localStorage.setItem('checkinClicked', JSON.stringify(checkinClicked.value))
}

async function Checkin() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  if (attendanceStore.editedAttendance.fullName == currentUser.fullName) {
    attendanceStore.editedAttendance.email = currentUser.email
    attendanceStore.editedAttendance.timeIn = date
    attendanceStore.editedAttendance.timeOut = date
    await attendanceStore.saveAttendance()
    status.value = 'working'
    checkinClicked.value = true
    saveCheckinClickedState()
    localStorage.setItem('status', 'working')

    closeDialog()
  } else {
    attendanceStore.clearForm()
  }
}

async function Checkout(item: Attendance) {
  checkinClicked.value = false
  saveCheckinClickedState()
  if (!item.id) return
  await attendanceStore.getAttendance(item.id)
  attendanceStore.editedAttendance.timeOut = date
  await attendanceStore.saveAttendance()
  status.value = 'unemployed'
  localStorage.setItem('status', 'unemployed')
  attendanceStore.clearForm()

  const index = checkedOutItems.value.findIndex((i) => i.id === item.id)
  if (index === -1) {
    checkedOutItems.value.push(item)
  } else {
    checkedOutItems.value.splice(index, 1)
  }
  localStorage.setItem('checkedOutItems', JSON.stringify(checkedOutItems.value))
}

watch(status, (newStatus) => {
  localStorage.setItem('status', newStatus)
})

onMounted(() => {
  attendanceStore.getAttendances()
  const storedItems = localStorage.getItem('checkedOutItems')
  if (storedItems) {
    checkedOutItems.value = JSON.parse(storedItems)
  }

  const savedStatus = localStorage.getItem('status')
  if (savedStatus) {
    status.value = savedStatus
  }
})

const disagree = () => {
  dialogcheckin.value = false
}

const mapContent = ref('')
navigator.geolocation.getCurrentPosition((position) => {
  const { latitude, longitude } = position.coords
  mapContent.value =
    '<iframe width="100%" height="300" src ="https://maps.google.com/maps?q=' +
    latitude +
    ',' +
    longitude +
    '&amp;z=15&amp;output=embed"></iframe>'
})
</script>
<template>
  <div class="text-center pa-4 bg-grey-darken-4" style="height: 1000px">
    <v-container fluid>
      <v-row>
        <v-col><v-card width="880px">report</v-card> </v-col>
        <v-col cols="6" class="text-right">
          <!-- Checkin dialog  -->
          <v-dialog v-model="dialogcheckin" max-width="400" persistent>
            <v-card title="CHECK IN">
              <div v-html="mapContent" class="ma-3"></div>

              <div class="ma-3 text-center">{{ currentUser.email }}</div>

              <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                <v-text-field
                  v-model="attendanceStore.editedAttendance.fullName"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="ma-2"
                  clearable
                  variant="outlined"
                  label="ลงชื่อ (ชื่อ-สกุล)"
                ></v-text-field>
              </v-form>
              <template v-slot:actions>
                <v-spacer></v-spacer>
                <v-btn @click="closeDialog()" color="red"> Cancel </v-btn>
                <v-btn @click="Checkin()" color="green"> Submit </v-btn>
              </template>
            </v-card>
          </v-dialog>
          <!-- Name and Status  -->
          <v-card max-width="1000px" class="text-left">
            <v-container>
              <v-row>
                <v-col cols="1"><v-avatar color="surface-variant" size="62"></v-avatar></v-col>
                <v-col class="text-left" cols="6">
                  <div class="ma-2">{{ currentUser.fullName }}</div>
                  <div>
                    <v-icon
                      :color="status === 'working' ? 'green' : 'red'"
                      icon="mdi-circle"
                      size="xx-small"
                      class="ma-2"
                    ></v-icon>
                    <span :style="{ color: status === 'working' ? 'green' : 'red' }">{{
                      status
                    }}</span>
                  </div>
                </v-col>
                <v-col cols="5" class="text-right">
                  <v-btn
                    class="ma-3"
                    v-if="!checkinClicked"
                    @click="dialogcheckin = true"
                    color="green"
                  >
                    CHECK IN
                  </v-btn>
                </v-col>
              </v-row>
            </v-container>
          </v-card>
          <!-- Table checkin Today  -->
          <v-card max-width="1000px" title="Today" class="text-left" style="margin-top: 1%">
            <v-table fixed-header height="120px" style="overflow: auto; width: 1000px">
              <thead>
                <tr>
                  <th class="text-center">Count</th>
                  <th class="text-center">ID</th>
                  <th class="text-center">Name</th>
                  <th class="text-center">Email</th>
                  <th class="text-center">TimeIn</th>
                  <th class="text-center">Status</th>
                  <th class="text-center"></th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(item, index) in filteredAttendancesToday" :key="item.id">
                  <td class="text-center">
                    {{ filteredAttendancesHistory.length - index + 1 }}
                  </td>
                  <td class="text-center">{{ currentUser.id }}</td>
                  <td class="text-center">{{ item.fullName }}</td>
                  <td class="text-center">{{ item.email }}</td>
                  <td class="text-center">{{ item.timeIn }}</td>
                  <td class="text-center">
                    <v-btn v-if="!isCheckedOut(item)" @click="Checkout(item)" color="red"
                      >CHECK OUT</v-btn
                    >
                    <span v-else style="color: green"> Complete : {{ item.timeOut }}</span>
                  </td>
                </tr>
              </tbody>
            </v-table>
          </v-card>
          <!-- Table checkin out History  -->
          <v-card
            max-width="1000px"
            title="History"
            prepend-icon="mdi-history"
            class="text-left"
            style="margin-top: 1%"
          >
            <v-table fixed-header height="450px" style="overflow: auto; width: 1000px">
              <thead>
                <tr>
                  <th class="text-center">Count</th>
                  <th class="text-center">ID</th>
                  <th class="text-center">Name</th>
                  <th class="text-center">Email</th>
                  <th class="text-center">TimeIn</th>
                  <th class="text-center">TimeOut</th>
                  <th class="text-center">Status</th>
                  <th class="text-center"></th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(item, index) in filteredAttendancesHistory" :key="item.id">
                  <td class="text-center">
                    {{ editedIndex + filteredAttendancesHistory.length - index }}
                  </td>
                  <td class="text-center">{{ currentUser.id }}</td>
                  <td class="text-center">{{ item.fullName }}</td>
                  <td class="text-center">{{ item.email }}</td>
                  <td class="text-center">{{ item.timeIn }}</td>
                  <td class="text-center">{{ item.timeOut }}</td>
                  <td class="text-center">
                    <span style="color: green">Complete</span>
                  </td>
                </tr>
              </tbody>
            </v-table>
          </v-card>
          <!-- Checkout dialog -->
          <!-- <v-dialog v-model="dialogcheckout" max-width="400" persistent>
            <v-card prepend-icon="mdi-map-marker" title="CHECK OUT">
              <div v-html="mapContent" class="ma-3"></div>
              <div class="text-center">{{ formattedDate }}</div>
              <template v-slot:actions>
                <v-spacer></v-spacer>

                <v-btn @click="dialogcheckout = false" color="red"> Cancel </v-btn>

                <v-btn @click="confirm = true" color="green"> Submit </v-btn>
              </template>
            </v-card>
          </v-dialog> -->
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>

<style scoped>
#app {
  background-color: #212121;
  height: 100%;
}
</style>
